%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function DB_Node_Delete(Node_list)

global ErrCode;

global DB_NODES;
global AT_NODES;

global AST_COORD;
global AT_COORD;

Node_list = unique(Node_list);

% Проверка существования в базе узлов
for i=1:size(Node_list,1)
    if (~DB_Node_Exist(Node_list(i)))
        fprintf (1, '\nОшибка функции DB_Node_Delete: узел с номером %i отсутствует в базе !\n', Node_list(i));
        ErrCode = -1;
        return;
    end
end

% Проверка задействованности узлов
for i=1:size(Node_list,1)
    
    Elm_list = Get_Elements_From_Nodes(Node_list(i), []);
    
    if (~isempty(Elm_list))
        if (size(Elm_list,1) == 1)
            elm_word = 'элементе';
        else
            elm_word = 'элементах';
        end
        fprintf (1, '\nОшибка функции DB_Node_Delete: узел с номером %i используется в %s:\n', Node_list(i), elm_word);
        column_print_counter = 0;
        row_print_counter = 0;
        for j=1:size(Elm_list,1)
            fprintf (1, ' %i', Elm_list(j));
            column_print_counter = column_print_counter + 1;
            if (column_print_counter == 10)
                column_print_counter = 0;
                row_print_counter = row_print_counter + 1;
                fprintf (1, '\n');
            end
            if (row_print_counter == 10)
                break;
            end
        end
        if (j < size(Elm_list,1))
            fprintf (1, '(показано %i элементов из %i)\n', j, size(Elm_list,1));
        else
            fprintf (1, '\n');
        end
        ErrCode = -1;
        return;
    end
    
    MPC_list = Get_MPCs_From_Nodes(Node_list(i), []);
    
    if (~isempty(MPC_list))
        fprintf (1, '\nОшибка функции DB_Node_Delete: узел с номером %i используется в MPC:\n', Node_list(i));
        column_print_counter = 0;
        row_print_counter = 0;
        for j=1:size(MPC_list,1)
            fprintf (1, ' %i', MPC_list(j));
            column_print_counter = column_print_counter + 1;
            if (column_print_counter == 10)
                column_print_counter = 0;
                row_print_counter = row_print_counter + 1;
                fprintf (1, '\n');
            end
            if (row_print_counter == 10)
                break;
            end
        end
        if (j < size(MPC_list,1))
            fprintf (1, '(показано %i MPC из %i)\n', j, size(MPC_list,1));
        else
            fprintf (1, '\n');
        end
        ErrCode = -1;
        return;
    end
    
end

% Внесение изменений в таблицу ассоциативности систем координат
for i=1:size(Node_list,1)
    
    if (DB_NODES{AT_NODES(Node_list(i))}.Reference_CID ~= 0)
        AST_COORD{AT_COORD(DB_NODES{AT_NODES(Node_list(i))}.Reference_CID)}.Node_list = setdiff(AST_COORD{AT_COORD(DB_NODES{AT_NODES(Node_list(i))}.Reference_CID)}.Node_list, Node_list(i));
        if (isempty(AST_COORD{AT_COORD(DB_NODES{AT_NODES(Node_list(i))}.Reference_CID)}.Node_list))
            AST_COORD{AT_COORD(DB_NODES{AT_NODES(Node_list(i))}.Reference_CID)}.Node_list = [];
        end
    end
    
    if ((DB_NODES{AT_NODES(Node_list(i))}.Analysis_CID ~= 0) && (DB_NODES{AT_NODES(Node_list(i))}.Analysis_CID ~= DB_NODES{AT_NODES(Node_list(i))}.Reference_CID))
        AST_COORD{AT_COORD(DB_NODES{AT_NODES(Node_list(i))}.Analysis_CID)}.Node_list = setdiff(AST_COORD{AT_COORD(DB_NODES{AT_NODES(Node_list(i))}.Analysis_CID)}.Node_list, Node_list(i));
        if (isempty(AST_COORD{AT_COORD(DB_NODES{AT_NODES(Node_list(i))}.Analysis_CID)}.Node_list))
            AST_COORD{AT_COORD(DB_NODES{AT_NODES(Node_list(i))}.Analysis_CID)}.Node_list = [];
        end
    end

end

% Удаление узлов из базы данных и адресной таблицы
for i=1:size(Node_list,1)
    
    DB_NODES{AT_NODES(Node_list(i))}.ID = -1;
    AT_NODES(Node_list(i)) = 0;

end
